/**************************************************************************
 *                                                                        *
 *   Copyright (c) Digital Equipment  Corporation,  1991.   All  Rights   *
 *   Reserved.  Unpublished rights reserved under the copyright laws of   *
 *   the United States.                                                   *
 *                                                                        *
 *   The software  contained  on  this  media  is  proprietary  to  and   *
 *   embodies   the   confidential   technology  of  Digital  Equipment   *
 *   Corporation.  Possession, use, duplication or dissemination of the   *
 *   software  and media is authorized only pursuant to a valid written   *
 *   license from Digital Equipment Corporation.                          *
 *                                                                        *
 *   RESTRICTED RIGHTS LEGEND Use, duplication, or  disclosure  by  the   *
 *   U.S.   Government  is  subject  to  restrictions  as  set forth in   *
 *   Subparagraph  (c)(1)(ii)  of  DFARS  252.227-7013,   or   in   FAR   *
 *   52.227-19, as applicable.                                            *
 *                                                                        *
 **************************************************************************/
#ifdef SCCS
static char sccsid[]="@(#)io_funs.c	5.1 Stardent 90/08/17";
#endif
/*
			Copyright (c) 1989 by
			Stardent Computer Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Stardent Computer Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under sccs control at Stardent in:
	/sccs3.p/avs/examples/s.io_funs.c
	
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>

/* On some systems, file.h contains all necessary defs and fcntl.h does not exist */
#ifndef O_RDONLY
#include <sys/fcntl.h>
#endif

/*----------------------------------------------------------------------
Open a given file for either "read" access or "write" access
and return the file descriptor.

If the file descriptor is < 0 the operation failed
----------------------------------------------------------------------*/
   
int 
CFopen(fn, mode )
   char *fn, *mode;
{
   if (!strcmp(mode,"read"))
      return (open(fn, O_RDONLY, 0664));
   else 
      return (open(fn, O_WRONLY | O_CREAT, 0664));
}

/*----------------------------------------------------------------------
Close the given file descriptor
----------------------------------------------------------------------*/

int
CFclose(fd)
   int fd;
{
   if (fd > 0)
      return(close(fd));
   return(0);
}

/*----------------------------------------------------------------------
Binary write NB bytes from BUF out to file FD

A return code of -1 indicates that the operation failed.
----------------------------------------------------------------------*/

int 
CFwrite(fd, buf, nb)
   int fd, nb;
   char *buf;
{
   return (write(fd, buf, nb));
}

/*----------------------------------------------------------------------
Binary read NB bytes from file FD into BUF

A positive return value indicates the number of bytes actually read.
A return code of -1 indicates that the operation failed.
----------------------------------------------------------------------*/

int 
CFread(fd, buf, nb)
   int fd, nb;
   char *buf;
{
   return (read(fd, buf, nb));
}
